require 'sqlite3'

module DmLiveResources
  class Resource
    class << self
      def db
        if File.exists? "Resources.db"
          @db = SQLite3::Database.open "Resources.db"
        else
          @db = SQLite3::Database.new "Resources.db"
        end
      end

      def remove_db
        File.delete("Resources.db") if File.exists? "Resources.db"
      end

      def update_required?(row,
      	                 sheet)
        return row['GSheetContent'] != sheet.content
      end

      def return_tables
        # List of all tables in db
        tables = db.execute("SELECT name FROM sqlite_master WHERE type='table'").flatten
        return tables
      end

      def data_as_hash(gs_api_key, gs_identifier, gs_sheets, gs_title, dm_api_key, dm_id)
        data = { gs_api_key: gs_api_key,
                 gs_identifier: gs_identifier,
                 gs_sheets: gs_sheets,
                 gs_title: gs_title,
                 dm_api_key: dm_api_key,
                 dm_id: dm_id}
        return data
      end

      def add_gsheet_data(data_hash,
      	                file,
      	                title)
        data_hash[:file] = file
        data_hash[:description] = title
        return data_hash
      end

      def insert_query(table)
        return %Q{INSERT INTO '#{table}' ( GSheetApiKey, GSheetIdentifier, GSheetTitle, GSheetContent, GSheetSheets, DMagicApiKey, DMagicId ) VALUES ( ?,?,?,?,?,?,? )}
      end
    end
  end
end
